#pragma once

#include "gridservice.h"

namespace cs
{
    class MFObjectPart;
    class MFObjectFull;
}

class Room;
class Obstacle;
class ColliderComponent;
class AabbCollider;
class CircleCollider;
class Entity
{
 public:
    int entity_uniid = 0;
    EntityType_e entity_type = ET_None;
    EntitySubType_e entity_subtype = EST_None;
    long long create_frameno = 0;
    Room* room = nullptr;
    a8::Vec2 pos;
    int updated_times = 0;
    bool deleted = false;
    a8::XTimerAttacher xtimer_attacher;
    bool dead = false;
    long long dead_frameno = 0;

    int grid_id = 0;
    std::set<GridCell*> grid_list;

    Entity();
    virtual ~Entity();
    virtual void Initialize();
    virtual void Update(int delta_time) {};
    virtual void FillMFObjectPart(cs::MFObjectPart* part_data) {};
    virtual void FillMFObjectFull(cs::MFObjectFull* full_data) {};
    virtual float GetSpeed() { return 1.0f;};
    virtual void GetAabbBox(AabbCollider& aabb_box);
    virtual void GetCircleBox(CircleCollider& circle_box);
    bool TestCollision(Entity* b);
    bool TestCollision(ColliderComponent* b);
    bool TestCollisionEx(const a8::Vec2& aabb_pos, AabbCollider& aabb_box);
    void BroadcastFullState();
    void BroadcastDeleteState();
    void AddCollider(ColliderComponent* collider);

private:
    std::list<ColliderComponent*> colliders;

    void ClearColliders();
};
