#include "precompile.h"

#include "frameevent.h"
#include "human.h"
#include "metamgr.h"
#include "typeconvert.h"

void FrameEvent::AddEmote(Human* hum, int emote_id)
{
    {
        auto& tuple = a8::FastAppend(emotes_);
        std::get<0>(tuple) = hum;
        auto& p = std::get<1>(tuple);

        p.set_emote_id(emote_id);
        p.set_player_id(hum->entity_uniid);
    }
    {
        int emote_idx = emotes_.size() - 1;
        for (auto& cell : hum->grid_list) {
            for (auto& hum : cell->human_list) {
                hum->emotes_.push_back(emote_idx);
            }
        }
    }
}

void FrameEvent::Clear()
{
    if (!emotes_.empty()) {
        emotes_.clear();
    }
}
