#include "precompile.h"

#include "framemaker.h"
#include "human.h"
#include "room.h"
#include "typeconvert.h"

cs::SMUpdate* FrameMaker::MakeUpdateMsg(const Human* hum)
{
    cs::SMUpdate* msg = new cs::SMUpdate;
    {
        Room* room = hum->room;
        for (auto& itr : hum->new_objects) {
            itr->FillMFObjectFull(msg->add_full_objects());
        }
        for (auto& itr : hum->part_objects) {
            Entity* entity = itr;
            if (entity->dead && hum->room->frame_no - entity->dead_frameno > 10) {
                continue;
            }
            entity->FillMFObjectPart(msg->add_part_objects());
        }
        for (auto& itr : hum->del_objects) {
            msg->add_del_objids(itr);
        }
        for (auto& itr : hum->out_objects) {
            msg->add_out_objids(itr);
        }
        msg->set_alive_count(room->AliveCount());
    }
    return msg;
}
