#pragma once

#include "human.h"

namespace cs
{
    class CMMove;
    class CMDropItem;
    class CMEmote;
    class CMVoice;
    class MFActivePlayerData;
}

class Room;
class Loot;
class Obstacle;
class Player : public Human
{
 public:
    enum { HID = HID_Player };

 public:
    int team_mode = 0;
    long long create_tick = 0;

    int last_seq_id = 0;
    bool moving = false;
    int moved_frames = 0;

    bool use_item = false;
    int use_item_idx = 0;

    bool spectate = false;

    bool emote = false;
    int emote_id = 0;

    Player();
    virtual ~Player() override;
    virtual void Initialize() override;
    virtual void Update(int delta_time) override;
    void UpdateMove();
    void UpdateSpectate();
    void UpdateEmote();

    void _CMMove(f8::MsgHdr& hdr, const cs::CMMove& msg);
    void _CMEmote(f8::MsgHdr& hdr, const cs::CMEmote& msg);
    void _CMVoice(f8::MsgHdr& hdr, const cs::CMVoice& msg);
    void _CMGameOver(f8::MsgHdr& hdr, const cs::CMGameOver& msg);
    void _CMWatchWar(f8::MsgHdr& hdr, const cs::CMWatchWar& msg);
    void _CMLeave(f8::MsgHdr& hdr, const cs::CMLeave& msg);
    void _CMRevive(f8::MsgHdr& hdr, const cs::CMRevive& msg);

};
