#pragma once

struct PerfMonitor
{
    int max_run_delay_time = 0;
    int max_dispatchmsg_time = 0;
    int max_timer_idle = 0;
    long long out_data_size = 0;
    long long in_data_size = 0;
    long long read_count = 0;
    long long grid_chg_times = 0;
    long long test_times = 0;
    long long alive_count = 0;
    std::array<long long, 30> params = {};
    std::array<int, 30> entity_num = {};
};

struct GasData
{
    GasMode_e gas_mode = GasInactive;
    long long gas_start_frameno = 0;
    bool is_last_gas = false;
};

struct PlayerStats
{
    int kills = 0;
    int damage_amount_in = 0;
    int damage_amount_out = 0;
    int heal_amount = 0;
    int rescue_member = 0;

    int history_time_alive = 0;
    int history_kills = 0;
    int history_damage_amount = 0;
    int history_heal_amount = 0;

    int gold = 0;
    int score = 0;
    int pass_score = 0;
    int rank_score = 0;

    std::vector<std::pair<int, int>> extra_drop;

    int killer_id = 0;
    std::string killer_name;
    int weapon_id = 0;

    int rank = 0;
};

struct HumanAbility
{
    float speed = 0.0f;
    float damage_add = 0.0f;
    float def_add = 0.0f;
    float reflect_damage = 0.0f;
};

struct SnakeBodyNode
{
    int node_id = 0;
    float speed = 0.0f;
    float radius = 0.0f;
    a8::Vec2 pos;
    a8::Vec2 dir;
    bool moved = false;
    struct SnakeBodyNode* pre_node = nullptr;
};
